// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:wyatt_bloc_helper/src/bloc_base/bloc_base_consumer_screen.dart';
import 'package:wyatt_bloc_helper/src/bloc_base/bloc_base_provider_screen.dart';
import 'package:wyatt_bloc_helper/src/bloc_base/bloc_base_screen.dart';
import 'package:wyatt_bloc_helper/src/mixins/bloc_base_provider_mixin.dart';
import 'package:wyatt_bloc_helper/src/mixins/bloc_provider_mixin.dart';

abstract class BlocProviderScreen<B extends Bloc<E, S>, E, S extends Object>
    extends BlocBaseProviderScreen<B, S>
    with BlocBaseProviderMixin<B>, BlocProviderMixin<B, E> {
  const BlocProviderScreen({super.key});
}

abstract class BlocConsumerScreen<B extends Bloc<E, S>, E, S extends Object>
    extends BlocBaseConsumerScreen<B, S>
    with BlocBaseProviderMixin<B>, BlocProviderMixin<B, E> {
  const BlocConsumerScreen({super.key});
}

abstract class BlocScreen<B extends Bloc<E, S>, E, S extends Object>
    extends BlocBaseScreen<B, S>
    with BlocBaseProviderMixin<B>, BlocProviderMixin<B, E> {
  const BlocScreen({super.key});
}
