// ignore_for_file: public_member_api_docs, sort_constructors_first
// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:http/http.dart';
import 'package:wyatt_http_client/src/models/middleware_context.dart';
import 'package:wyatt_http_client/src/models/middleware_request.dart';

class MiddlewareResponse {
  BaseResponse httpResponse;
  MiddlewareRequest middlewareRequest;
  MiddlewareContext context;

  MiddlewareResponse({
    required this.httpResponse,
    required this.middlewareRequest,
    required this.context,
  }) {
    context = context.copyWith(originalResponse: this);
  }

  MiddlewareResponse copyWith({
    BaseResponse? httpResponse,
    MiddlewareRequest? middlewareRequest,
    MiddlewareContext? context,
  }) {
    return MiddlewareResponse(
      httpResponse: httpResponse ?? this.httpResponse,
      middlewareRequest: middlewareRequest ?? this.middlewareRequest,
      context: context ?? this.context,
    );
  }

  @override
  String toString() => 'MiddlewareResponse(httpResponse: $httpResponse, '
      'middlewareRequest: $middlewareRequest, context: $context)';
}
